/*******************************************************************************
 Copyright (c) Microsoft Open Technologies, Inc. All Rights Reserved.
 Licensed under the MIT or Apache License; see LICENSE in the source repository
 root for authoritative license information.﻿

 **NOTE** This code was generated by a tool and will occasionally be
 overwritten. We welcome comments and issues regarding this code; they will be
 addressed in the generation tool. If you wish to submit pull requests, please
 do so for the templates in that tool.

 This code was generated by Vipr (https://github.com/microsoft/vipr) using
 the T4TemplateWriter (https://github.com/msopentech/vipr-t4templatewriter).
 ******************************************************************************/
package com.microsoft.graph;

/**
 * The type Application.
*/
public class Application extends DirectoryObject {

    public Application(){
        setODataType("#Microsoft.Graph.Application");
    }
            
    private String appId;
     
    /**
    * Gets the app Id.
    *
    * @return the String
    */
    public String getappId() {
        return this.appId; 
    }

    /**
    * Sets the app Id.
    *
    * @param value the String
    */
    public void setappId(String value) { 
        this.appId = value; 
    }
    
    
    private java.util.List<AppRole> appRoles = new java.util.ArrayList<AppRole>();
    
    
     
    /**
    * Gets the app Roles.
    *
    * @return the java.util.List<AppRole>
    */
    public java.util.List<AppRole> getappRoles() {
        return this.appRoles; 
    }

    /**
    * Sets the app Roles.
    *
    * @param value the java.util.List<AppRole>
    */
    public void setappRoles(java.util.List<AppRole> value) { 
        this.appRoles = value; 
    }
            
    private Boolean availableToOtherTenants;
     
    /**
    * Gets the available To Other Tenants.
    *
    * @return the Boolean
    */
    public Boolean getavailableToOtherTenants() {
        return this.availableToOtherTenants; 
    }

    /**
    * Sets the available To Other Tenants.
    *
    * @param value the Boolean
    */
    public void setavailableToOtherTenants(Boolean value) { 
        this.availableToOtherTenants = value; 
    }
            
    private String displayName;
     
    /**
    * Gets the display Name.
    *
    * @return the String
    */
    public String getdisplayName() {
        return this.displayName; 
    }

    /**
    * Sets the display Name.
    *
    * @param value the String
    */
    public void setdisplayName(String value) { 
        this.displayName = value; 
    }
            
    private String errorUrl;
     
    /**
    * Gets the error Url.
    *
    * @return the String
    */
    public String geterrorUrl() {
        return this.errorUrl; 
    }

    /**
    * Sets the error Url.
    *
    * @param value the String
    */
    public void seterrorUrl(String value) { 
        this.errorUrl = value; 
    }
            
    private String groupMembershipClaims;
     
    /**
    * Gets the group Membership Claims.
    *
    * @return the String
    */
    public String getgroupMembershipClaims() {
        return this.groupMembershipClaims; 
    }

    /**
    * Sets the group Membership Claims.
    *
    * @param value the String
    */
    public void setgroupMembershipClaims(String value) { 
        this.groupMembershipClaims = value; 
    }
            
    private String homepage;
     
    /**
    * Gets the homepage.
    *
    * @return the String
    */
    public String gethomepage() {
        return this.homepage; 
    }

    /**
    * Sets the homepage.
    *
    * @param value the String
    */
    public void sethomepage(String value) { 
        this.homepage = value; 
    }
    
    
    private java.util.List<String> identifierUris = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the identifier Uris.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getidentifierUris() {
        return this.identifierUris; 
    }

    /**
    * Sets the identifier Uris.
    *
    * @param value the java.util.List<String>
    */
    public void setidentifierUris(java.util.List<String> value) { 
        this.identifierUris = value; 
    }
    
    
    private java.util.List<KeyCredential> keyCredentials = new java.util.ArrayList<KeyCredential>();
    
    
     
    /**
    * Gets the key Credentials.
    *
    * @return the java.util.List<KeyCredential>
    */
    public java.util.List<KeyCredential> getkeyCredentials() {
        return this.keyCredentials; 
    }

    /**
    * Sets the key Credentials.
    *
    * @param value the java.util.List<KeyCredential>
    */
    public void setkeyCredentials(java.util.List<KeyCredential> value) { 
        this.keyCredentials = value; 
    }
    
    
    private java.util.List<String> knownClientApplications = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the known Client Applications.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getknownClientApplications() {
        return this.knownClientApplications; 
    }

    /**
    * Sets the known Client Applications.
    *
    * @param value the java.util.List<String>
    */
    public void setknownClientApplications(java.util.List<String> value) { 
        this.knownClientApplications = value; 
    }
            
    private byte[] mainLogo;
     
    /**
    * Gets the main Logo.
    *
    * @return the byte[]
    */
    public byte[] getmainLogo() {
        return this.mainLogo; 
    }

    /**
    * Sets the main Logo.
    *
    * @param value the byte[]
    */
    public void setmainLogo(byte[] value) { 
        this.mainLogo = value; 
    }
            
    private String logoutUrl;
     
    /**
    * Gets the logout Url.
    *
    * @return the String
    */
    public String getlogoutUrl() {
        return this.logoutUrl; 
    }

    /**
    * Sets the logout Url.
    *
    * @param value the String
    */
    public void setlogoutUrl(String value) { 
        this.logoutUrl = value; 
    }
            
    private Boolean oauth2AllowImplicitFlow;
     
    /**
    * Gets the oauth2Allow Implicit Flow.
    *
    * @return the Boolean
    */
    public Boolean getoauth2AllowImplicitFlow() {
        return this.oauth2AllowImplicitFlow; 
    }

    /**
    * Sets the oauth2Allow Implicit Flow.
    *
    * @param value the Boolean
    */
    public void setoauth2AllowImplicitFlow(Boolean value) { 
        this.oauth2AllowImplicitFlow = value; 
    }
            
    private Boolean oauth2AllowUrlPathMatching;
     
    /**
    * Gets the oauth2Allow Url Path Matching.
    *
    * @return the Boolean
    */
    public Boolean getoauth2AllowUrlPathMatching() {
        return this.oauth2AllowUrlPathMatching; 
    }

    /**
    * Sets the oauth2Allow Url Path Matching.
    *
    * @param value the Boolean
    */
    public void setoauth2AllowUrlPathMatching(Boolean value) { 
        this.oauth2AllowUrlPathMatching = value; 
    }
    
    
    private java.util.List<OAuth2Permission> oauth2Permissions = new java.util.ArrayList<OAuth2Permission>();
    
    
     
    /**
    * Gets the oauth2Permissions.
    *
    * @return the java.util.List<OAuth2Permission>
    */
    public java.util.List<OAuth2Permission> getoauth2Permissions() {
        return this.oauth2Permissions; 
    }

    /**
    * Sets the oauth2Permissions.
    *
    * @param value the java.util.List<OAuth2Permission>
    */
    public void setoauth2Permissions(java.util.List<OAuth2Permission> value) { 
        this.oauth2Permissions = value; 
    }
            
    private Boolean oauth2RequirePostResponse;
     
    /**
    * Gets the oauth2Require Post Response.
    *
    * @return the Boolean
    */
    public Boolean getoauth2RequirePostResponse() {
        return this.oauth2RequirePostResponse; 
    }

    /**
    * Sets the oauth2Require Post Response.
    *
    * @param value the Boolean
    */
    public void setoauth2RequirePostResponse(Boolean value) { 
        this.oauth2RequirePostResponse = value; 
    }
    
    
    private java.util.List<PasswordCredential> passwordCredentials = new java.util.ArrayList<PasswordCredential>();
    
    
     
    /**
    * Gets the password Credentials.
    *
    * @return the java.util.List<PasswordCredential>
    */
    public java.util.List<PasswordCredential> getpasswordCredentials() {
        return this.passwordCredentials; 
    }

    /**
    * Sets the password Credentials.
    *
    * @param value the java.util.List<PasswordCredential>
    */
    public void setpasswordCredentials(java.util.List<PasswordCredential> value) { 
        this.passwordCredentials = value; 
    }
            
    private Boolean publicClient;
     
    /**
    * Gets the public Client.
    *
    * @return the Boolean
    */
    public Boolean getpublicClient() {
        return this.publicClient; 
    }

    /**
    * Sets the public Client.
    *
    * @param value the Boolean
    */
    public void setpublicClient(Boolean value) { 
        this.publicClient = value; 
    }
    
    
    private java.util.List<String> replyUrls = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the reply Urls.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getreplyUrls() {
        return this.replyUrls; 
    }

    /**
    * Sets the reply Urls.
    *
    * @param value the java.util.List<String>
    */
    public void setreplyUrls(java.util.List<String> value) { 
        this.replyUrls = value; 
    }
    
    
    private java.util.List<RequiredResourceAccess> requiredResourceAccess = new java.util.ArrayList<RequiredResourceAccess>();
    
    
     
    /**
    * Gets the required Resource Access.
    *
    * @return the java.util.List<RequiredResourceAccess>
    */
    public java.util.List<RequiredResourceAccess> getrequiredResourceAccess() {
        return this.requiredResourceAccess; 
    }

    /**
    * Sets the required Resource Access.
    *
    * @param value the java.util.List<RequiredResourceAccess>
    */
    public void setrequiredResourceAccess(java.util.List<RequiredResourceAccess> value) { 
        this.requiredResourceAccess = value; 
    }
            
    private String samlMetadataUrl;
     
    /**
    * Gets the saml Metadata Url.
    *
    * @return the String
    */
    public String getsamlMetadataUrl() {
        return this.samlMetadataUrl; 
    }

    /**
    * Sets the saml Metadata Url.
    *
    * @param value the String
    */
    public void setsamlMetadataUrl(String value) { 
        this.samlMetadataUrl = value; 
    }
    
    
    private java.util.List<ExtensionProperty> extensionProperties = new java.util.ArrayList<ExtensionProperty>();
    
    
     
    /**
    * Gets the extension Properties.
    *
    * @return the java.util.List<ExtensionProperty>
    */
    public java.util.List<ExtensionProperty> getextensionProperties() {
        return this.extensionProperties; 
    }

    /**
    * Sets the extension Properties.
    *
    * @param value the java.util.List<ExtensionProperty>
    */
    public void setextensionProperties(java.util.List<ExtensionProperty> value) { 
        this.extensionProperties = value; 
    }
            
    private DirectoryObject createdOnBehalfOf;
     
    /**
    * Gets the created On Behalf Of.
    *
    * @return the DirectoryObject
    */
    public DirectoryObject getcreatedOnBehalfOf() {
        return this.createdOnBehalfOf; 
    }

    /**
    * Sets the created On Behalf Of.
    *
    * @param value the DirectoryObject
    */
    public void setcreatedOnBehalfOf(DirectoryObject value) { 
        this.createdOnBehalfOf = value; 
    }
    
    
    private java.util.List<DirectoryObject> owners = new java.util.ArrayList<DirectoryObject>();
    
    
     
    /**
    * Gets the owners.
    *
    * @return the java.util.List<DirectoryObject>
    */
    public java.util.List<DirectoryObject> getowners() {
        return this.owners; 
    }

    /**
    * Sets the owners.
    *
    * @param value the java.util.List<DirectoryObject>
    */
    public void setowners(java.util.List<DirectoryObject> value) { 
        this.owners = value; 
    }
}

