/*******************************************************************************
 Copyright (c) Microsoft Open Technologies, Inc. All Rights Reserved.
 Licensed under the MIT or Apache License; see LICENSE in the source repository
 root for authoritative license information.﻿

 **NOTE** This code was generated by a tool and will occasionally be
 overwritten. We welcome comments and issues regarding this code; they will be
 addressed in the generation tool. If you wish to submit pull requests, please
 do so for the templates in that tool.

 This code was generated by Vipr (https://github.com/microsoft/vipr) using
 the T4TemplateWriter (https://github.com/msopentech/vipr-t4templatewriter).
 ******************************************************************************/
package com.microsoft.graph;

/**
 * The type Service Principal.
*/
public class ServicePrincipal extends DirectoryObject {

    public ServicePrincipal(){
        setODataType("#Microsoft.Graph.ServicePrincipal");
    }
            
    private Boolean accountEnabled;
     
    /**
    * Gets the account Enabled.
    *
    * @return the Boolean
    */
    public Boolean getaccountEnabled() {
        return this.accountEnabled; 
    }

    /**
    * Sets the account Enabled.
    *
    * @param value the Boolean
    */
    public void setaccountEnabled(Boolean value) { 
        this.accountEnabled = value; 
    }
            
    private String appDisplayName;
     
    /**
    * Gets the app Display Name.
    *
    * @return the String
    */
    public String getappDisplayName() {
        return this.appDisplayName; 
    }

    /**
    * Sets the app Display Name.
    *
    * @param value the String
    */
    public void setappDisplayName(String value) { 
        this.appDisplayName = value; 
    }
            
    private String appId;
     
    /**
    * Gets the app Id.
    *
    * @return the String
    */
    public String getappId() {
        return this.appId; 
    }

    /**
    * Sets the app Id.
    *
    * @param value the String
    */
    public void setappId(String value) { 
        this.appId = value; 
    }
            
    private java.util.UUID appOwnerTenantId;
     
    /**
    * Gets the app Owner Tenant Id.
    *
    * @return the java.util.UUID
    */
    public java.util.UUID getappOwnerTenantId() {
        return this.appOwnerTenantId; 
    }

    /**
    * Sets the app Owner Tenant Id.
    *
    * @param value the java.util.UUID
    */
    public void setappOwnerTenantId(java.util.UUID value) { 
        this.appOwnerTenantId = value; 
    }
            
    private Boolean appRoleAssignmentRequired;
     
    /**
    * Gets the app Role Assignment Required.
    *
    * @return the Boolean
    */
    public Boolean getappRoleAssignmentRequired() {
        return this.appRoleAssignmentRequired; 
    }

    /**
    * Sets the app Role Assignment Required.
    *
    * @param value the Boolean
    */
    public void setappRoleAssignmentRequired(Boolean value) { 
        this.appRoleAssignmentRequired = value; 
    }
    
    
    private java.util.List<AppRole> appRoles = new java.util.ArrayList<AppRole>();
    
    
     
    /**
    * Gets the app Roles.
    *
    * @return the java.util.List<AppRole>
    */
    public java.util.List<AppRole> getappRoles() {
        return this.appRoles; 
    }

    /**
    * Sets the app Roles.
    *
    * @param value the java.util.List<AppRole>
    */
    public void setappRoles(java.util.List<AppRole> value) { 
        this.appRoles = value; 
    }
            
    private String displayName;
     
    /**
    * Gets the display Name.
    *
    * @return the String
    */
    public String getdisplayName() {
        return this.displayName; 
    }

    /**
    * Sets the display Name.
    *
    * @param value the String
    */
    public void setdisplayName(String value) { 
        this.displayName = value; 
    }
            
    private String errorUrl;
     
    /**
    * Gets the error Url.
    *
    * @return the String
    */
    public String geterrorUrl() {
        return this.errorUrl; 
    }

    /**
    * Sets the error Url.
    *
    * @param value the String
    */
    public void seterrorUrl(String value) { 
        this.errorUrl = value; 
    }
            
    private String homepage;
     
    /**
    * Gets the homepage.
    *
    * @return the String
    */
    public String gethomepage() {
        return this.homepage; 
    }

    /**
    * Sets the homepage.
    *
    * @param value the String
    */
    public void sethomepage(String value) { 
        this.homepage = value; 
    }
    
    
    private java.util.List<KeyCredential> keyCredentials = new java.util.ArrayList<KeyCredential>();
    
    
     
    /**
    * Gets the key Credentials.
    *
    * @return the java.util.List<KeyCredential>
    */
    public java.util.List<KeyCredential> getkeyCredentials() {
        return this.keyCredentials; 
    }

    /**
    * Sets the key Credentials.
    *
    * @param value the java.util.List<KeyCredential>
    */
    public void setkeyCredentials(java.util.List<KeyCredential> value) { 
        this.keyCredentials = value; 
    }
            
    private String logoutUrl;
     
    /**
    * Gets the logout Url.
    *
    * @return the String
    */
    public String getlogoutUrl() {
        return this.logoutUrl; 
    }

    /**
    * Sets the logout Url.
    *
    * @param value the String
    */
    public void setlogoutUrl(String value) { 
        this.logoutUrl = value; 
    }
    
    
    private java.util.List<OAuth2Permission> oauth2Permissions = new java.util.ArrayList<OAuth2Permission>();
    
    
     
    /**
    * Gets the oauth2Permissions.
    *
    * @return the java.util.List<OAuth2Permission>
    */
    public java.util.List<OAuth2Permission> getoauth2Permissions() {
        return this.oauth2Permissions; 
    }

    /**
    * Sets the oauth2Permissions.
    *
    * @param value the java.util.List<OAuth2Permission>
    */
    public void setoauth2Permissions(java.util.List<OAuth2Permission> value) { 
        this.oauth2Permissions = value; 
    }
    
    
    private java.util.List<PasswordCredential> passwordCredentials = new java.util.ArrayList<PasswordCredential>();
    
    
     
    /**
    * Gets the password Credentials.
    *
    * @return the java.util.List<PasswordCredential>
    */
    public java.util.List<PasswordCredential> getpasswordCredentials() {
        return this.passwordCredentials; 
    }

    /**
    * Sets the password Credentials.
    *
    * @param value the java.util.List<PasswordCredential>
    */
    public void setpasswordCredentials(java.util.List<PasswordCredential> value) { 
        this.passwordCredentials = value; 
    }
            
    private String preferredTokenSigningKeyThumbprint;
     
    /**
    * Gets the preferred Token Signing Key Thumbprint.
    *
    * @return the String
    */
    public String getpreferredTokenSigningKeyThumbprint() {
        return this.preferredTokenSigningKeyThumbprint; 
    }

    /**
    * Sets the preferred Token Signing Key Thumbprint.
    *
    * @param value the String
    */
    public void setpreferredTokenSigningKeyThumbprint(String value) { 
        this.preferredTokenSigningKeyThumbprint = value; 
    }
            
    private String publisherName;
     
    /**
    * Gets the publisher Name.
    *
    * @return the String
    */
    public String getpublisherName() {
        return this.publisherName; 
    }

    /**
    * Sets the publisher Name.
    *
    * @param value the String
    */
    public void setpublisherName(String value) { 
        this.publisherName = value; 
    }
    
    
    private java.util.List<String> replyUrls = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the reply Urls.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getreplyUrls() {
        return this.replyUrls; 
    }

    /**
    * Sets the reply Urls.
    *
    * @param value the java.util.List<String>
    */
    public void setreplyUrls(java.util.List<String> value) { 
        this.replyUrls = value; 
    }
            
    private String samlMetadataUrl;
     
    /**
    * Gets the saml Metadata Url.
    *
    * @return the String
    */
    public String getsamlMetadataUrl() {
        return this.samlMetadataUrl; 
    }

    /**
    * Sets the saml Metadata Url.
    *
    * @param value the String
    */
    public void setsamlMetadataUrl(String value) { 
        this.samlMetadataUrl = value; 
    }
    
    
    private java.util.List<String> servicePrincipalNames = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the service Principal Names.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getservicePrincipalNames() {
        return this.servicePrincipalNames; 
    }

    /**
    * Sets the service Principal Names.
    *
    * @param value the java.util.List<String>
    */
    public void setservicePrincipalNames(java.util.List<String> value) { 
        this.servicePrincipalNames = value; 
    }
    
    
    private java.util.List<String> tags = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the tags.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> gettags() {
        return this.tags; 
    }

    /**
    * Sets the tags.
    *
    * @param value the java.util.List<String>
    */
    public void settags(java.util.List<String> value) { 
        this.tags = value; 
    }
            
    private AppRoleAssignment appRoleAssignedTo;
     
    /**
    * Gets the app Role Assigned To.
    *
    * @return the AppRoleAssignment
    */
    public AppRoleAssignment getappRoleAssignedTo() {
        return this.appRoleAssignedTo; 
    }

    /**
    * Sets the app Role Assigned To.
    *
    * @param value the AppRoleAssignment
    */
    public void setappRoleAssignedTo(AppRoleAssignment value) { 
        this.appRoleAssignedTo = value; 
    }
    
    
    private java.util.List<AppRoleAssignment> appRoleAssignments = new java.util.ArrayList<AppRoleAssignment>();
    
    
     
    /**
    * Gets the app Role Assignments.
    *
    * @return the java.util.List<AppRoleAssignment>
    */
    public java.util.List<AppRoleAssignment> getappRoleAssignments() {
        return this.appRoleAssignments; 
    }

    /**
    * Sets the app Role Assignments.
    *
    * @param value the java.util.List<AppRoleAssignment>
    */
    public void setappRoleAssignments(java.util.List<AppRoleAssignment> value) { 
        this.appRoleAssignments = value; 
    }
    
    
    private java.util.List<OAuth2PermissionGrant> oauth2PermissionGrants = new java.util.ArrayList<OAuth2PermissionGrant>();
    
    
     
    /**
    * Gets the oauth2Permission Grants.
    *
    * @return the java.util.List<OAuth2PermissionGrant>
    */
    public java.util.List<OAuth2PermissionGrant> getoauth2PermissionGrants() {
        return this.oauth2PermissionGrants; 
    }

    /**
    * Sets the oauth2Permission Grants.
    *
    * @param value the java.util.List<OAuth2PermissionGrant>
    */
    public void setoauth2PermissionGrants(java.util.List<OAuth2PermissionGrant> value) { 
        this.oauth2PermissionGrants = value; 
    }
    
    
    private java.util.List<DirectoryObject> memberOf = new java.util.ArrayList<DirectoryObject>();
    
    
     
    /**
    * Gets the member Of.
    *
    * @return the java.util.List<DirectoryObject>
    */
    public java.util.List<DirectoryObject> getmemberOf() {
        return this.memberOf; 
    }

    /**
    * Sets the member Of.
    *
    * @param value the java.util.List<DirectoryObject>
    */
    public void setmemberOf(java.util.List<DirectoryObject> value) { 
        this.memberOf = value; 
    }
            
    private DirectoryObject createdOnBehalfOf;
     
    /**
    * Gets the created On Behalf Of.
    *
    * @return the DirectoryObject
    */
    public DirectoryObject getcreatedOnBehalfOf() {
        return this.createdOnBehalfOf; 
    }

    /**
    * Sets the created On Behalf Of.
    *
    * @param value the DirectoryObject
    */
    public void setcreatedOnBehalfOf(DirectoryObject value) { 
        this.createdOnBehalfOf = value; 
    }
    
    
    private java.util.List<DirectoryObject> createdObjects = new java.util.ArrayList<DirectoryObject>();
    
    
     
    /**
    * Gets the created Objects.
    *
    * @return the java.util.List<DirectoryObject>
    */
    public java.util.List<DirectoryObject> getcreatedObjects() {
        return this.createdObjects; 
    }

    /**
    * Sets the created Objects.
    *
    * @param value the java.util.List<DirectoryObject>
    */
    public void setcreatedObjects(java.util.List<DirectoryObject> value) { 
        this.createdObjects = value; 
    }
    
    
    private java.util.List<DirectoryObject> owners = new java.util.ArrayList<DirectoryObject>();
    
    
     
    /**
    * Gets the owners.
    *
    * @return the java.util.List<DirectoryObject>
    */
    public java.util.List<DirectoryObject> getowners() {
        return this.owners; 
    }

    /**
    * Sets the owners.
    *
    * @param value the java.util.List<DirectoryObject>
    */
    public void setowners(java.util.List<DirectoryObject> value) { 
        this.owners = value; 
    }
    
    
    private java.util.List<DirectoryObject> ownedObjects = new java.util.ArrayList<DirectoryObject>();
    
    
     
    /**
    * Gets the owned Objects.
    *
    * @return the java.util.List<DirectoryObject>
    */
    public java.util.List<DirectoryObject> getownedObjects() {
        return this.ownedObjects; 
    }

    /**
    * Sets the owned Objects.
    *
    * @param value the java.util.List<DirectoryObject>
    */
    public void setownedObjects(java.util.List<DirectoryObject> value) { 
        this.ownedObjects = value; 
    }
}

