/*******************************************************************************
 Copyright (c) Microsoft Open Technologies, Inc. All Rights Reserved.
 Licensed under the MIT or Apache License; see LICENSE in the source repository
 root for authoritative license information.﻿

 **NOTE** This code was generated by a tool and will occasionally be
 overwritten. We welcome comments and issues regarding this code; they will be
 addressed in the generation tool. If you wish to submit pull requests, please
 do so for the templates in that tool.

 This code was generated by Vipr (https://github.com/microsoft/vipr) using
 the T4TemplateWriter (https://github.com/msopentech/vipr-t4templatewriter).
 ******************************************************************************/
package com.microsoft.graph;

/**
 * The type Tenant Detail.
*/
public class TenantDetail extends DirectoryObject {

    public TenantDetail(){
        setODataType("#Microsoft.Graph.TenantDetail");
    }
    
    
    private java.util.List<AssignedPlan> assignedPlans = new java.util.ArrayList<AssignedPlan>();
    
    
     
    /**
    * Gets the assigned Plans.
    *
    * @return the java.util.List<AssignedPlan>
    */
    public java.util.List<AssignedPlan> getassignedPlans() {
        return this.assignedPlans; 
    }

    /**
    * Sets the assigned Plans.
    *
    * @param value the java.util.List<AssignedPlan>
    */
    public void setassignedPlans(java.util.List<AssignedPlan> value) { 
        this.assignedPlans = value; 
    }
            
    private String city;
     
    /**
    * Gets the city.
    *
    * @return the String
    */
    public String getcity() {
        return this.city; 
    }

    /**
    * Sets the city.
    *
    * @param value the String
    */
    public void setcity(String value) { 
        this.city = value; 
    }
            
    private java.util.Calendar companyLastDirSyncTime;
     
    /**
    * Gets the company Last Dir Sync Time.
    *
    * @return the java.util.Calendar
    */
    public java.util.Calendar getcompanyLastDirSyncTime() {
        return this.companyLastDirSyncTime; 
    }

    /**
    * Sets the company Last Dir Sync Time.
    *
    * @param value the java.util.Calendar
    */
    public void setcompanyLastDirSyncTime(java.util.Calendar value) { 
        this.companyLastDirSyncTime = value; 
    }
            
    private String country;
     
    /**
    * Gets the country.
    *
    * @return the String
    */
    public String getcountry() {
        return this.country; 
    }

    /**
    * Sets the country.
    *
    * @param value the String
    */
    public void setcountry(String value) { 
        this.country = value; 
    }
            
    private String countryLetterCode;
     
    /**
    * Gets the country Letter Code.
    *
    * @return the String
    */
    public String getcountryLetterCode() {
        return this.countryLetterCode; 
    }

    /**
    * Sets the country Letter Code.
    *
    * @param value the String
    */
    public void setcountryLetterCode(String value) { 
        this.countryLetterCode = value; 
    }
            
    private Boolean dirSyncEnabled;
     
    /**
    * Gets the dir Sync Enabled.
    *
    * @return the Boolean
    */
    public Boolean getdirSyncEnabled() {
        return this.dirSyncEnabled; 
    }

    /**
    * Sets the dir Sync Enabled.
    *
    * @param value the Boolean
    */
    public void setdirSyncEnabled(Boolean value) { 
        this.dirSyncEnabled = value; 
    }
            
    private String displayName;
     
    /**
    * Gets the display Name.
    *
    * @return the String
    */
    public String getdisplayName() {
        return this.displayName; 
    }

    /**
    * Sets the display Name.
    *
    * @param value the String
    */
    public void setdisplayName(String value) { 
        this.displayName = value; 
    }
    
    
    private java.util.List<String> marketingNotificationEmails = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the marketing Notification Emails.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getmarketingNotificationEmails() {
        return this.marketingNotificationEmails; 
    }

    /**
    * Sets the marketing Notification Emails.
    *
    * @param value the java.util.List<String>
    */
    public void setmarketingNotificationEmails(java.util.List<String> value) { 
        this.marketingNotificationEmails = value; 
    }
            
    private String postalCode;
     
    /**
    * Gets the postal Code.
    *
    * @return the String
    */
    public String getpostalCode() {
        return this.postalCode; 
    }

    /**
    * Sets the postal Code.
    *
    * @param value the String
    */
    public void setpostalCode(String value) { 
        this.postalCode = value; 
    }
            
    private String preferredLanguage;
     
    /**
    * Gets the preferred Language.
    *
    * @return the String
    */
    public String getpreferredLanguage() {
        return this.preferredLanguage; 
    }

    /**
    * Sets the preferred Language.
    *
    * @param value the String
    */
    public void setpreferredLanguage(String value) { 
        this.preferredLanguage = value; 
    }
    
    
    private java.util.List<ProvisionedPlan> provisionedPlans = new java.util.ArrayList<ProvisionedPlan>();
    
    
     
    /**
    * Gets the provisioned Plans.
    *
    * @return the java.util.List<ProvisionedPlan>
    */
    public java.util.List<ProvisionedPlan> getprovisionedPlans() {
        return this.provisionedPlans; 
    }

    /**
    * Sets the provisioned Plans.
    *
    * @param value the java.util.List<ProvisionedPlan>
    */
    public void setprovisionedPlans(java.util.List<ProvisionedPlan> value) { 
        this.provisionedPlans = value; 
    }
    
    
    private java.util.List<ProvisioningError> provisioningErrors = new java.util.ArrayList<ProvisioningError>();
    
    
     
    /**
    * Gets the provisioning Errors.
    *
    * @return the java.util.List<ProvisioningError>
    */
    public java.util.List<ProvisioningError> getprovisioningErrors() {
        return this.provisioningErrors; 
    }

    /**
    * Sets the provisioning Errors.
    *
    * @param value the java.util.List<ProvisioningError>
    */
    public void setprovisioningErrors(java.util.List<ProvisioningError> value) { 
        this.provisioningErrors = value; 
    }
    
    
    private java.util.List<String> securityComplianceNotificationMails = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the security Compliance Notification Mails.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getsecurityComplianceNotificationMails() {
        return this.securityComplianceNotificationMails; 
    }

    /**
    * Sets the security Compliance Notification Mails.
    *
    * @param value the java.util.List<String>
    */
    public void setsecurityComplianceNotificationMails(java.util.List<String> value) { 
        this.securityComplianceNotificationMails = value; 
    }
    
    
    private java.util.List<String> securityComplianceNotificationPhones = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the security Compliance Notification Phones.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> getsecurityComplianceNotificationPhones() {
        return this.securityComplianceNotificationPhones; 
    }

    /**
    * Sets the security Compliance Notification Phones.
    *
    * @param value the java.util.List<String>
    */
    public void setsecurityComplianceNotificationPhones(java.util.List<String> value) { 
        this.securityComplianceNotificationPhones = value; 
    }
            
    private String state;
     
    /**
    * Gets the state.
    *
    * @return the String
    */
    public String getstate() {
        return this.state; 
    }

    /**
    * Sets the state.
    *
    * @param value the String
    */
    public void setstate(String value) { 
        this.state = value; 
    }
            
    private String street;
     
    /**
    * Gets the street.
    *
    * @return the String
    */
    public String getstreet() {
        return this.street; 
    }

    /**
    * Sets the street.
    *
    * @param value the String
    */
    public void setstreet(String value) { 
        this.street = value; 
    }
    
    
    private java.util.List<String> technicalNotificationMails = new java.util.ArrayList<String>();
    
    
     
    /**
    * Gets the technical Notification Mails.
    *
    * @return the java.util.List<String>
    */
    public java.util.List<String> gettechnicalNotificationMails() {
        return this.technicalNotificationMails; 
    }

    /**
    * Sets the technical Notification Mails.
    *
    * @param value the java.util.List<String>
    */
    public void settechnicalNotificationMails(java.util.List<String> value) { 
        this.technicalNotificationMails = value; 
    }
            
    private String telephoneNumber;
     
    /**
    * Gets the telephone Number.
    *
    * @return the String
    */
    public String gettelephoneNumber() {
        return this.telephoneNumber; 
    }

    /**
    * Sets the telephone Number.
    *
    * @param value the String
    */
    public void settelephoneNumber(String value) { 
        this.telephoneNumber = value; 
    }
    
    
    private java.util.List<VerifiedDomain> verifiedDomains = new java.util.ArrayList<VerifiedDomain>();
    
    
     
    /**
    * Gets the verified Domains.
    *
    * @return the java.util.List<VerifiedDomain>
    */
    public java.util.List<VerifiedDomain> getverifiedDomains() {
        return this.verifiedDomains; 
    }

    /**
    * Sets the verified Domains.
    *
    * @param value the java.util.List<VerifiedDomain>
    */
    public void setverifiedDomains(java.util.List<VerifiedDomain> value) { 
        this.verifiedDomains = value; 
    }
}

